% Define any helpful macros here.

% Parentheses, braces, brackets.
\newcommand*{\parens}[1]{\left( #1 \right)}
\newcommand*{\paren}[1]{\left( #1 \right)}
\newcommand*{\braces}[1]{ \{ #1 \} }
\newcommand*{\brackets}[1]{ \left[ #1 \right] }

% Math stuff.
\DeclareMathOperator*{\argmin}{\arg\!\min}
\DeclareMathOperator*{\argmax}{\arg\!\max}

% Default table and figure dimensions.
\newcommand{\defaultTableWidth}{0.9 \textwidth}
\newcommand{\defaultFigWidth}{0.65}
\newcommand{\defaultAxisWidth}{0.7\textwidth}
\newcommand{\defaultAxisHeight}{0.5\textwidth}

% Footnote for an entire chapter -- no symbol, just text at the bottom.
\newcommand{\chapternote}[1]{{%
  \let\thempfn\relax% Remove footnote number printing mechanism
  \footnotetext[0]{\emph{#1}}% Print footnote text
}}

\newcommand{\tabulargraphics}[2][width=0.25\textwidth]{
  \raisebox{-.5\height}{\includegraphics[#1]{#2}}
}

\newcommand{\subdir}{\currfiledir\currfilebase}

% Left superscripts and subscripts
\newcommand\leftidx[3]{%
  {\vphantom{#2}}#1#2#3%
}

\def\agent{temp}
\def\subsystem{temp}

\newcommand\fter[1]{\leftidx{^\subsystem}{f}{^\tau_{\agent ,#1}}}
\newcommand\fini[1]{\leftidx{^\subsystem}{f}{^\sigma_{\agent ,#1}}}
\newcommand\ferr[1]{\leftidx{^\subsystem}{f}{^\varepsilon_{\agent ,#1}}}

\newcommand\ftrans[1]{
  \leftidx{^{\subsystem ,e}}{f}{_{\agent ,#1}}
}

\newcommand\state[1]{\leftidx{^\subsystem}{\mathcal{S}}{_{\agent ,#1}}}
\newcommand\B[1]{\leftidx{^\subsystem}{\mathcal{B}}{_{\agent ,#1}}}
\newcommand\memory[0]{\leftidx{^\subsystem}{\subsystem}{_\agent}}
\newcommand\ve[1]{e_{\agent ,#1}}
\newcommand\E[1]{E_{\agent ,#1}}
\newcommand\ex[1]{\leftidx{^e_x}{\subsystem}{_{\agent ,#1}}}
\newcommand\ey[1]{\leftidx{^e_y}{\subsystem}{_{\agent ,#1}}}
\newcommand\vr[1]{r_{\agent ,#1}}
\newcommand\R[1]{R_{\agent ,#1}}
\newcommand\rx[1]{\leftidx{^r_x}{\subsystem}{_{\agent ,#1}}}
\newcommand\ry[1]{\leftidx{^r_y}{\subsystem}{_{\agent ,#1}}}
\newcommand\Tx[1]{\leftidx{^T_x}{\subsystem}{_{\agent ,#1}}}
\newcommand\T[2]{\leftidx{^{#1}_{#2}}{T}}
\def\Objects{\leftidx{^{B}_{1..V}}{O}{_c}}
\def\PrevObjects{\leftidx{^{B}_{1..V}}{O}{_p}}
\def\Object{\leftidx{^{B}_{v}}{O}{_c}}
\def\Target{\leftidx{^{B}_{t}}{O}{_c}}
\def\PrevTarget{\leftidx{^{B}_{t}}{O}{_p}}

% This is creepy as f***
\gdef\@tempS{temp}
\newcounter{tempNS}
\newcommand\incrementNS[1]{\stepcounter{tempNS}}
\newcommand\insertmultirow[1]{ %
  $\fini{\@tempS,#1}=TRUE$ & $\state{#1}$ \\ \cline{5-6} & & & & %
}
\NewDocumentCommand{\SBrow}{
  m % State
  o % Behaviour
  m % Description
  >{\SplitList{,}}o % Other next states
  m % Next state
  }{%
  \gdef\@tempS{#1}%
  \setcounter{tempNS}{1}%
  \IfNoValueF{#4}{\ProcessList{#4}{\incrementNS}}%
  \multirow{\thetempNS}{*}{$\state{\@tempS}$}
  & \multirow{\thetempNS}{*}{$\fter{\@tempS}=TRUE$} 
  & \multirow{\thetempNS}{*}{$\B{\IfNoValueTF{#2}{#1}{#2}}$} 
  & \multirow{\thetempNS}{*}{#3} 
  & \IfNoValueF{#4}{\ProcessList{#4}{\insertmultirow}}
  $\fini{#1,#5}=TRUE$ & $\state{#5}$ \\ \hline
}


\newcommand\SInistate[2]{\state{#1}}
\newcommand\SInistates[2]{\state{#1}, }
\NewDocumentCommand{\SInicallstates}{>{\SplitArgument{1}{;}}m}{\SInistates #1}
\newcommand\SInisubrow[2]{$\fini{\@tempS ,#1} \triangleq$ #2 \\}
\NewDocumentCommand{\SInicallsubrow}{>{\SplitArgument{1}{;}}m}{\SInisubrow #1}
\NewDocumentCommand{\SInirow}{
  m % State
  >{\SplitList{,}}o % Other next states
  >{\SplitArgument{1}{;}}m % Next state
  }{%
  \gdef\@tempS{#1}%
  $\hat{\state{\@tempS}} = \left\{
    \IfNoValueF{#2}{\ProcessList{#2}{\SInicallstates}} \SInistate #3
    \right\}$
  & \begin{tabular}{l} 
    \IfNoValueF{#2}{\ProcessList{#2}{\SInicallsubrow}}
    \SInisubrow #3
  \end{tabular} \\
}

\newcommand\STerrow[2]{$\fter{#1}$ & $\triangleq $ & #2\\}